
use16
org  0x0600           ;//    
jmp  @start           ;//   -

menu          db  '   Help   '
              db  ' PCI Dump '
              db  '  CPU-Id  '
              db  '  SMBIOS  '
              db  ' ATA/SATA '
              db  '  P-Mode  '
menuEnd       db  ' PowerOff '
menuLen       =   $ - menuEnd
CheckBox      db  '******'

help          db 'Key [1]. This page describes the menu items.                      '
              db 'Key [2]. Page with information about devices on the PCI bus.      '
              db 'Key [3]. CPUID and RAM physical memory allocation map.            '
              db 'Key [4]. Parse information from SMBIOS and DMI tables.            '
              db 'Key [5]. Information about the installed ATA/SATA hard drive.     '
              db 'Key [6]. Transition to CPU x64 Protected Mode with virtual memory.'
helpEnd       db 'Key [7]. You can Reboot the operating system & Power Off.         '
helpLen       =  $ - helpEnd

logo          db "  ____             _        _                             _   "
              db " / __ \           | |      | |                           | |  "
              db "| /  \/  ___    __| |  ___ | |__   _   _     _ __    ___ | |_ "
              db "| |     / _ \  / _` | / _ \| '_ \ | | | |   | '_ \  / _ \| __|"
              db "| \__/\| (_) || (_| ||  __/| |_) || |_| | _ | | | ||  __/| |_ "
              db " \____/ \___/  \__,_| \___||_.__/  \__, |(_)|_| |_| \___| \__|"
              db "                                    __/ |                     "
logoEnd       db "                                   |___/                      "
logoLen       =   $ - logoEnd

Blue          =   0001b
Green         =   0010b
Red           =   0100b
Cyan          =   0011b
Pink          =   0101b
Yellow        =   0110b
White         =   1111b
Gray          =   0111b

;//---------------------------------------------------------------
PrintString:
         push   es 0xb800
         pop    es
@@:      lodsb
         stosw
         loop   @b
         pop    es
ret
ClearScreen:
         push   es 0xb800
         pop    es
         mov    ax,' '
         mov    di,160*2
         mov    cx,80*26
         rep    stosw
         pop    es
ret
SetCheckBox:
         mov    si,CheckBox
         mov    cx,6
         mov    ah,Cyan           ;// 
         call   PrintString
ret
;----    EC    HEX ------------
PrintHex:
         pusha
         push   es 0xb800        ;
         pop    es               ;
         mov    di,[cursor]      ; ES:DI =   800:0000
         xchg   edx,ecx          ; EDX = 
         mov    ecx,[dataSize]   ; -   
@@:      shld   eax,edx,4        ;   AL  
         rol    edx,4            ;    EDX
         and    al,0x0f          ;   AL   
         cmp    al,0x0a          ;   
         sbb    al,0x69          ;    ..hex   AL
         das                     ;        ..  ASCII-
         mov    ah,Yellow        ;  
         stosw                   ;  A  
         loop   @b               ;    
         pop    es               ;
         popa
ret

;//*************************************************
align 16
@start:

;//-----    txt  --------------
         mov    ax,0x1110
         mov    bx,0x0e00
         mov    cx,128
         mov    dx,0
         mov    bp,myFont
         int    10h

;// ..   /  -  
         mov    ah,1
         mov    cx,0x2000
         int    10h

;//    
         mov    di,(160)+4       ;//    ( 2)
         mov    si,menu          ;//   
         mov    cx,menuLen       ;//    
         mov    ah,00110000b     ;// :    
         mov    bp,7
@@:      push   cx
         call   PrintString      ;// !
         pop    cx
         add    di,2
         dec    bp
         jnz    @b

@HelpPage:
         call   ClearScreen
         mov    di,(160*2)+8      ;//   
         call   SetCheckBox

         mov    di,(160*4)+18     ;//   
         mov    si,logo
         mov    cx,logoLen
         mov    ah,Green          ;// 
         mov    bp,8              ;//  
@@:      push   cx di
         call   PrintString
         pop    di cx
         add    di,160
         dec    bp
         jnz    @b

         mov    di,(160*14)+8     ;//   HELP
         mov    si,help
         mov    cx,helpLen
         mov    ah,Gray           ;// 
         mov    bp,7              ;//  
@@:      push   cx di
         call   PrintString
         pop    di cx
         add    di,160
         dec    bp
         jnz    @b

@GetMenuItem:
         xor    ax,ax
         int    16h

         cmp    al,'1'
         je     @HelpPage
         cmp    al,'2'
         je     @PciDumpPage
         cmp    al,'3'
         je     @CpuidPage
         cmp    al,'4'
         je     @SmbiosPage
         cmp    al,'5'
         je     @AtaSataPage
         cmp    al,'6'
         je     @ProtectedPage
         cmp    al,'7'
         je     @RebootPage
;         cmp    ah,0x48         ;// -   =0x75
;         je     @UpScroll
;         cmp    ah,0x50         ;// -    =0x72
;         je     @DownScroll
         jmp    @GetMenuItem

;//---------------------------
@UpScroll:
         mov    cx,0x0300
         mov    dx,0x1950
         xor    bx,bx
         mov    ax,0x0601
         int    10h
         jmp    @GetMenuItem

@DownScroll:
         mov    cx,0x0300
         mov    dx,0x1950
         xor    bx,bx
         mov    ax,0x0701
         int    10h
         jmp    @GetMenuItem

;//**************************************
include 'pci_cfg.inc'
include 'cpuid.inc'
include 'smbios.inc'
include 'sata.inc'
include 'pm.inc'
include 'reboot.inc'
