;//*************************************************************
;//***********    CPUID  *************************
;//*************************************************************
align 16
@CpuidPage:
         call   ClearScreen
         mov    di,(160*2)+52    ;//   
         call   SetCheckBox
         mov    di,buff
         xor    eax,eax
         mov    cx,128/4
         rep    stosd

         call   @f
          db    'Name string..:'
Identf    db    'Identifier...: Family     Model     Stepping     Revision'

RegValue  db    'CR0:           CR2:           CR3:           CR4:           ESP:'
          db    'TSC:                       EFLAGS:                              '
buff      db    128 dup(0)

@@:      pop    si              ;//  
         mov    di,(160*4)+4    ;//   
         mov    cx,14           ;//   
         mov    ah,Gray         ;//  
         call   PrintString

         mov    si,Identf
         mov    di,(160*5)+4    ;//   
         mov    cx,57           ;//   
         mov    ah,Gray         ;//  
         call   PrintString

         mov    si,RegValue
         mov    di,(160*7)+4    ;//   
         mov    cx,64           ;//   
         mov    ah,Gray         ;//  
         mov    bp,2
@@:      push   cx di bp
         call   PrintString
         pop    bp di cx
         add    di,160
         dec    bp
         jnz    @b

;//-----    : EAX=80000002 ------------------
         mov    edi,buff         ;//    STOSD
         mov    eax,0x80000002   ;//<---    (2)
         mov    bp,3
@@:      push   eax
         cpuid              ;//<---   CPUID
         nop
         stosd              ;//<---      EDI
         mov    eax,ebx
         stosd
         mov    eax,ecx
         stosd
         mov    eax,edx
         stosd
         pop    eax
         inc    eax        ;//<--- ...
         dec    bp         ;//<---  -1
         jnz    @b

         mov    si,buff
         mov    di,(160*4)+34     ;//   
         mov    cx,48             ;//   
         mov    ah,Yellow         ;//  
         call   PrintKillSpaceString

;//----- Family/Model/Stepping: EAX=1 --------------------------------
         mov    eax,1
         cpuid
         push   eax eax eax
         shr    ax,8
         and    ax,1111b                 ;// Family
         mov    cx,ax
         shl    ecx,24
         mov    [cursor],(160*5)+48
         mov    [dataSize],2
         call   PrintHex
         pop    ecx
         shr    cx,4
         and    cx,1111b                 ;// Model
         shl    ecx,24
         mov    [cursor],(160*5)+68
         mov    [dataSize],2
         call   PrintHex
         pop    ecx
         and    cx,1111b                 ;// Stepping
         shl    ecx,24
         mov    [cursor],(160*5)+94
         mov    [dataSize],2
         call   PrintHex
         pop    ecx
         shl    ecx,4                    ;// Revision
         mov    [cursor],(160*5)+120
         mov    [dataSize],2
         call   PrintHex

;//-----      -------------------
         mov    ecx,cr0
         mov    [cursor],(160*7)+14
         mov    [dataSize],8
         call   PrintHex
         mov    ecx,cr2
         mov    [cursor],(160*7)+44
         mov    [dataSize],8
         call   PrintHex
         mov    ecx,cr3
         mov    [cursor],(160*7)+74
         mov    [dataSize],8
         call   PrintHex
         mov    ecx,cr4
         mov    [cursor],(160*7)+104
         mov    [dataSize],8
         call   PrintHex
         mov    ecx,esp
         mov    [cursor],(160*7)+134
         mov    [dataSize],8
         call   PrintHex

         rdtsc
         push   eax
         xchg   edx,ecx
         mov    [cursor],(160*8)+14
         mov    [dataSize],8
         call   PrintHex
         pop    ecx
         mov    [cursor],(160*8)+30
         mov    [dataSize],8
         call   PrintHex

         xor    ecx,ecx
         pushf
         pop    cx
         mov    [cursor],(160*8)+74
         mov    [dataSize],8
         call   PrintHex

;//-----     -------------------------
         mov    si,MemMap
         mov    di,(160*10)+4     ;//   
         mov    cx,76             ;//   
         mov    ah,Cyan           ;//  
         call   PrintString

         mov    si,memTable
         mov    di,(160*12)+28    ;//   
         mov    cx,40             ;//   
         mov    ah,Gray           ;//  
         mov    bp,2
@@:      push   cx di bp
         call   PrintString
         pop    bp di cx
         add    di,160
         dec    bp
         jnz    @b

         mov    bp,160*14
         mov    [index],0
@NextMemoryMap:
         mov    ebx,[index]
         mov    di,AddressRangeDesc
;         mov    [ExtAttributes],1       ;//     ACPI 3.0
         mov    ecx,24
         mov    edx,0x534d4150          ;//  'SMAP'
         mov    eax,0xE820
         int    15h
         or     ebx,ebx
         jz     @stopMemoryMap
         mov    [index],ebx
         cmp    [Type],1
;         jnz    @NextMemoryMap         ;//   (2)

         mov    ecx,[BaseAddrHigh]
         mov    [cursor],bp
         add    [cursor],28
         mov    [dataSize],8
         call   PrintHex
         mov    ecx,[BaseAddrLow]
         mov    [cursor],bp
         add    [cursor],44
         mov    [dataSize],8
         call   PrintHex

         mov    ecx,[LenghtHigh]
         mov    [cursor],bp
         add    [cursor],64
         mov    [dataSize],8
         call   PrintHex
         mov    ecx,[LenghtLow]
         mov    [cursor],bp
         add    [cursor],80
         mov    [dataSize],8
         call   PrintHex

         mov    ecx,[Type]
         shl    ecx,16
         mov    [cursor],bp
         add    [cursor],100
         mov    [dataSize],4
         call   PrintHex

         mov    ebx,[Type]
         mov    si,TypeStr
         mov    cx,8
@@:      lodsw
         cmp    ax,bx
         je     @f
         add    si,2
         loop   @b
@@:      mov    si,[si]
         mov    di,bp
         add    di,112            ;//   
         mov    cx,8              ;//   
         mov    ah,Green          ;//  
         cmp    [Type],1
         jnz    @f
         or     ah,1000b
@@:      call   PrintString

         add    bp,160
         jmp    @NextMemoryMap
@stopMemoryMap:
         jmp    @GetMenuItem
;//-------------------------


MemMap    db    27 dup('-')
          db    '[ Physical Memory Map ]'
          db    27 dup('-')
memTable  db    '  Base Address         Lenght       Type'
          db    '----------------  ----------------  ----'
index     dd    0

TypeStr   dw    01,@01,02,@02,03,@03,04,@04,05,@05,06,@06,07,@07,08,@08
@01       db    '<-- Free'
@02       db    'Reserved'
@03       db    'ACPI rsv'
@04       db    'ACPI NVS'
@05       db    'BadBlock'
@06       db    'Disabled'
@07       db    'ROM Bios'
@08       db    '        '

;// https://uefi.org/htmlspecs/ACPI_Spec_6_4_html/  #15
;// https://wiki.osdev.org/Detecting_Memory_(x86)
AddressRangeDesc:
BaseAddrLow     dd  0
BaseAddrHigh    dd  0
LenghtLow       dd  0
LenghtHigh      dd  0
Type            dd  0  ;//-------+
ExtAttributes   dd  0    ;//     |
                         ;//     V
FreeMemory      = 1      ;// 
Reserved        = 2      ;// 
ACPI            = 3      ;//  ACPI
NVS             = 4      ;//     (Non Vollatile Storage)
Bad             = 5      ;//  
Disabled        = 6      ;//  
RomMemory       = 7      ;// - 
OEM             = 12     ;//  

