;//*************************************************************
;//***********   PCI-Config-Space **************************
;//*************************************************************
align 16
@PciDumpPage:
         call   ClearScreen
         mov    di,(160*2)+30     ;//   
         call   SetCheckBox
         mov    [cursor],(160*6)+4
         call   @f
         db     ' Ven/Dev    B:D:F    Class                  BAR 0-3                Device  '
         db     '---------  --------  ------   -----------------------------------  --------'
         ;       0000:0000  00:00:00  000000   00000000 00000000 00000000 00000000
         ;       0000:0000  00:00:00  000000   00000000 00000000 00000000 00000000
cursor          dw  0
dataSize        dd  0
pciAddress      dd  0

@@:      pop    si              ;//  
         mov    di,(160*4)+4    ;//   
         mov    cx,75           ;//   
         mov    ah,Gray         ;//  
         mov    bp,2            ;//  
@@:      push   cx di
         call   PrintString
         pop    di cx
         add    di,160          ;//   .
         dec    bp
         jnz    @b

;//-----    PCI-Config-Space
         xor    bx,bx           ;// BH = Bus,  BL = Device
         xor    cx,cx           ;// CH = Func, CL = Register

@find:   call   ReadPciCfg
         cmp    eax,-1
         jnz    @deviceFound

@next:   inc    ch              ;//   
         cmp    ch,8            ;//   ???
         jnz    @find           ;//  -   
         xor    ch,ch           ;// :    

         inc    bl              ;//   
         cmp    bl,32           ;//  
         jnz    @find
         xor    bl,bl

         inc    bh              ;//   
         cmp    bh,255          ;//   
         jz     @stopFind       ;//   -  !
         jmp    @find

;//-----   EAX  PCI  /
ReadPciCfg:
         xor    eax,eax            ;//   
         mov    al,bh              ;//    
         or     ah,0x80            ;//   =1
         shl    eax,16             ;//   . 32- !
         mov    ah,bl              ;//    
         shl    ah,3               ;//   3- 
         or     ah,ch              ;//   
         mov    al,cl              ;//   .   
         and    al,11111100b       ;//  2-.  - 0/1
         mov    [pciAddress],eax   ;//    
         mov    dx,0x0CF8          ;//  CONFIG_ADDRESS
         out    dx,eax             ;//    !
         nop                       ;// ...  1- 
         mov    dx,0x0CFC          ;//  CONFIG_DATA
         in     eax,dx             ;//    !
         nop                       ;// ...  1- 
ret
@deviceFound:
         push   cx bx
         push   [cursor]
         rol    eax,16             ;// Vendor/Device
         xchg   eax,ecx
         push   ecx
         mov    [dataSize],4
         call   PrintHex
         mov    di,[cursor]        ;// 
         add    di,8
         call   GetSeparator
         pop    ecx
         shl    ecx,16
         add    [cursor],10
         mov    [dataSize],4
         call   PrintHex

;//----- Bus:Dev:Func ---------------------------
         mov    ecx,[pciAddress]
         shl    ecx,8              ;// Bus(8) =   8 
         add    [cursor],12
         mov    [dataSize],2
         call   PrintHex

         mov    di,[cursor]
         add    di,4
         call   GetSeparator

         mov    ecx,[pciAddress]
         shl    ecx,16             ;// Device(5) =   16,
         shr    ecx,3              ;//   3 
         add    [cursor],6
         mov    [dataSize],2
         call   PrintHex

         mov    di,[cursor]
         add    di,4
         call   GetSeparator

         mov    ecx,[pciAddress]
         shl    ecx,21            ;// Func(3) =   20 
         shr    ecx,5             ;//   5 
         add    [cursor],6
         mov    [dataSize],2
         call   PrintHex

;//----- Class\Subclass\Interface ---------------------------
         mov    eax,[pciAddress]
         mov    bl,2
         shl    bl,2
         mov    al,bl
         call   ReadPciConfigPort
         push   ecx
         add    [cursor],8
         mov    [dataSize],6
         call   PrintHex
         pop    eax
         shr    eax,24
         mov    [classCode],ax

;//-----  4-  BAR   ---------------------
         add    [cursor],18
         mov    bp,4
         mov    bx,4
@@:      push   bx bp
         mov    eax,[pciAddress]
         shl    bl,2
         mov    al,bl
         call   ReadPciConfigPort
         mov    [dataSize],8
         call   PrintHex
         add    [cursor],18
         pop    bp bx
         inc    bl
         dec    bp
         jnz    @b

;//-----     ------------------------
         mov    si,CodeTable
         mov    cx,16
         mov    bx,[classCode]
@@:      lodsw
         cmp    ax,bx
         jz     @foundDevString
         add    si,2
         loop   @b
@foundDevString:
         mov    si,[si]
         mov    di,[cursor]     ;//   
         add    di,2
         mov    cx,10           ;//   
         mov    ah,Green        ;//  
         call   PrintString

         pop    [cursor]
         add    [cursor],160
         pop    bx cx
         jmp    @next

@stopFind:
         jmp    @GetMenuItem

classCode       dw  0
CodeTable       dw  01,t01,02,t02,03,t03,04,t04,05,t05,06,t06,07,t07,08,t08
                dw  09,t09,10,t10,11,t11,12,t12,13,t13,14,t14,15,t15,16,t16
t01  db  'Storage   '
t02  db  'Network   '
t03  db  'Display   '
t04  db  'MultiMedia'
t05  db  'Memory    '
t06  db  'Bridge    '
t07  db  'SimpleComm'
t08  db  'Peripheria'
t09  db  'Input     '
t10  db  'Docking   '
t11  db  'CPUs      '
t12  db  'SerialBus '
t13  db  'Wireless  '
t14  db  'I/O contr '
t15  db  'Satellite '
t16  db  'Unknown   '

GetSeparator:
         push   es 0xb800
         pop    es
         mov    ah,Gray
         mov    al,':'
         stosw
         pop    es
ret
ReadPciConfigPort:
         mov    dx,0x0CF8
         out    dx,eax
         nop
         mov    dx,0x0CFC
         in     eax,dx
         nop
         xchg   eax,ecx
         nop
ret
