;//*************************************************************
;//***********    ATA/SATA  **************************
;//*************************************************************
align 16
@AtaSataPage:
         call   ClearScreen
         mov    di,(160*2)+96      ;//   
         call   SetCheckBox

         mov    [hddCursorPos],160*5      ;// (5)
         jmp    @f

fpuGb           dd  1024*1024*1024   ;//---\
secSize         dd  512              ;//    >--   FPU
diskSize        dq  0                ;//---/

MsSlave         db  0
devError        db  0

BarReg          dd  0
ahciPort        dd  0
portCount       dw  0

hddCursorPos    dw  0
devIdAddr       dw  0

@@:
;//*****************************************************************
         mov    ax,0xB103
         mov    ecx,0x010601     ;//<----- SATA-AHCI
         xor    si,si
         int    0x1a
         or     ah,ah
         jnz    @ahciNotFound

         mov    ax,0xB10A                ;//  DWORD  PCI-Cfg
         mov    di,0x24                  ;// BAR_5
         int    0x1a
         mov    [BarReg],ecx

;//-----    R/W  4Gb    FS
         call   SetUnrealMode

;//-----   HBA  ------------------
         mov    edi,[BarReg]
         mov    eax,[fs:edi+0x10]
         shr    eax,8
         and    eax,0xff
         add    al,'0'
         mov    byte[ahciHdr+13],al
         jmp    @f

ahciHdr  db     'SATA AHCI v1.0: 00000000  Speed:'   ;//   32
         db     '  Command list: 00000000  Ports:'
         db     ' FIS base addr: 00000000  Slots:'
         db     '                                '
         db     '   Port number:                 '
         db     '  Storage name:                 '
         db     ' Firmware / SN:                 '
         db     ' Total sectors:                 '
         db     '--------------------------------'

align 4
@@:      mov    si,ahciHdr            ;//  
         mov    di,(160*4)+4
         mov    cx,32
         mov    bp,9
@@:      push   di cx bp
         mov    ah,Gray
         call   PrintString
         pop    bp cx di
         add    di,160
         dec    bp
         jnz    @b

;//-----   AHCI   -----------------
         mov    [Color],Yellow
         mov    [cursor],(160*4)+36
         mov    [dataSize],8
         mov    ecx,[BarReg]
         call   PrintHex
         jmp    @f

;//-----  SATA  ---------------------
sataGen  db     '600 MB/s'    ;//   8
         db     '300 MB/s'    ;//    8b/10b
         db     '150 MB/s'    ;//   * 125 = 178 /

@@:      mov    edi,[BarReg]
         mov    eax,[fs:edi]
         push   eax eax
         shr    eax,20
         and    eax,1111b
         mov    si,sataGen
         cmp    al,3
         je     @printSataGen
         add    si,8
         cmp    al,2
         je     @printSataGen
         add    si,8
@printSataGen:
         mov    di,(160*4)+70
         mov    ah,Yellow
         mov    cx,8
         call   PrintString

;//-----  SATA   . ---------------
         pop    eax
         and    eax,1111b
         inc    al
         mov    [portCount],ax
         mov    di,(160*5)+70
         call   HexToDec

;//----- .-   -----------------
         pop    eax
         shr    eax,8
         and    eax,11111b
         inc    al
         mov    di,(160*6)+70
         call   HexToDec

;//-----    --------------------------
         mov    edi,[BarReg]
         add    edi,0x128            ;// Port.Status
         mov    cx,[portCount]
         mov    eax,1
@@:      mov    ebx,[fs:edi]
         and    bl,1111b
         cmp    bl,3
         je     @f
         add    edi,80h
         inc    al
         dec    cx
         jnz    @b

@@:      push   edi
         mov    di,(160*8)+36        ;//  
         call   HexToDec

         pop    eax
         sub    eax,0x28
         mov    [ahciPort],eax       ;//  (100h)  

;//*********************************************************************
;//***************  ˨ AHCI ***********************
;//*********************************************************************
         jmp    @initAhci

;//-----    Command.CtrlRunning(15)
StopAhciPort:
         mov    edi,[ahciPort]
         mov    eax,[fs:edi+18h]      ;// Command Register
         and    al,not 10001b         ;//   Command.ST + FRE
         mov    [fs:edi+18h],eax
@@:      mov    eax,[fs:edi+18h]      ;// Command Register
         bt     ax,15                 ;// bitTest Command.CR
         jc     @b
         bt     ax,14                 ;// bitTest Command.FR
         jc     @b
ret
StartAhciPort:
         mov    edi,[ahciPort]
@@:      mov    eax,[fs:edi+18h]      ;// Command Register
         bt     ax,15                 ;// bitTest Command.CR
         jc     @b
         or     al,10001b             ;//   Command.ST + FRE
         mov    [fs:edi+18h],eax
ret

@initAhci:
;//----- 1.   
         call   StopAhciPort

;//----- 2.   4 
         mov    edi,0x8000
         xor    eax,eax
         mov    ecx,1024
         rep    stosd

;//----- 3.   Command  FIS
         mov    edi,[ahciPort]
         mov    dword[fs:edi+0x00],0x8000       ;//  "Command List Address"
         mov    dword[fs:edi+0x08],0x8400       ;//  "FIS Base Address"

;//----- 4.  CmdHeader  
         mov    dword[0x8000+0x00],0x00010005   ;// DW0.PRDTL = 1  (. )
;         mov     byte[0x8000+0x00],0x85        ;// DW0.CFL   = 5  ( FIS) + 8 (Prefetch)
         mov    dword[0x8000+0x04],0            ;// DW1.PRDC  =  512 
         mov    dword[0x8000+0x08],0x8400       ;// DW2.CTBA  =  CmdTable

;//----- 5.     
         mov     word[0x8400+0x80],0x9000       ;// Data Base Address
         mov     word[0x8400+0x8C],512          ;// Byte Counter

;//----- 6.     
         call   StartAhciPort

;//*********************************************************************
;//*******************   ******************************
;//*********************************************************************

         mov    edi,[ahciPort]
         mov    ecx,[fs:edi]              ;//  "Command List"
         mov    [cursor],(160*5)+36
         call   PrintHex

         mov    edi,[ahciPort]
         mov    ecx,[fs:edi+0x08]         ;//  "FIS Base Address"
         mov    [cursor],(160*6)+36
         call   PrintHex

;//-----  FIS "Identify Device" -----------------
         mov    edi,[ahciPort]
         mov    ebx,[fs:edi+0x24]         ;//  "Signature"

         mov    eax,0x00EC8027            ;// EC=, 80=Write, 27=H2D
         cmp    ebx,0x00000101            ;//  SATA  ?
         je     @f
         mov    eax,0x00A18027            ;// A1=, 80=Write, 27=H2D
@@:      mov    dword[0x8400],eax

;//-----  "Command Issue" -    (1) !!!
         mov    edi,[ahciPort]
         mov    dword[fs:edi+0x38],1

;//-----     ..
@@:      mov    eax,[fs:edi+0x38]
         or     eax,eax
         jnz    @b

;//-----     AHCI -------------------
         mov    di,0x9000
         add    di,20         ;//   .
         mov    si,di
         mov    ecx,37        ;//  = 37  = 74 
@@:      lodsw
         xchg   ah,al         ;//   
         stosw
         loop   @b

         mov    si,0x9000
         add    si,54                   ;// / 
         mov    di,(160*9)+36
         mov    cx,40
         mov    ah,Yellow
         call   PrintString

         mov    si,0x9000
         add    si,46                   ;// 
         mov    di,(160*10)+36
         mov    cx,5
         mov    ah,Yellow
         call   PrintString

         mov    si,0x9000
         add    si,20                   ;// 
         mov    di,(160*10)+48
         mov    cx,20
         mov    ah,Yellow
         call   PrintString

         mov    eax,dword[0x9000+200]   ;//   48 
         mov    [Color],Yellow
         mov    di,(160*11)+36
         call   HexToDec

         add    di,2
         mov    si,equal                ;//  "="
         mov    ah,Yellow
         mov    cx,1
         call   PrintString

         finit
         fild   dword[0x9000+200]       ;//  48 
         fimul  dword[secSize]
         fidiv  dword[fpuGb]
         fistp  [diskSize]
         mov    eax,dword[diskSize]     ;//    
         add    di,2
         call   HexToDec
         mov    si,gBt
         mov    ah,Yellow
         mov    cx,3
         call   PrintString

         mov    [hddCursorPos],160*14

;//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
;//xxxxxxxxxxxxxxxxxxx ATA   IDE xxxxxxxxxxxxxxxxxxxxxx
;//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
@ahciNotFound:
         mov    [BarReg],0x1f0

         mov    ax,0xB103
         mov    ecx,0x01018A          ;//<---- ATA PCI_IDE
         xor    si,si
         int    0x1a
         or     ah,ah
         jz     @ataFound

         mov    ax,0xB103
         mov    ecx,0x01018F          ;//<---- ATA PCI_IDE
         xor    si,si
         int    0x1a
         or     ah,ah
         jz     @ataFound

         mov    ax,0xB103
         mov    ecx,0x010180          ;//<---- ATA Legacy
         xor    si,si
         int    0x1a
         or     ah,ah
         jnz    @ataNotFound

@ataFound:
         mov    ax,0xB10A             ;//  DWORD  PCI-Cfg
         mov    di,0x10               ;// BAR_0
         int    0x1a
         or     ecx,ecx
         jz     @f
         dec    ecx                   ;//  .
         or     ecx,ecx
         jz     @f
         mov    [BarReg],ecx          ;//  

@@:      mov    si,ataHdr             ;//  
         mov    di,[hddCursorPos]
         add    di,4
         mov    cx,15
         mov    bp,5
@@:      push   di cx bp
         mov    ah,Gray
         call   PrintString
         pop    bp cx di
         add    di,160
         dec    bp
         jnz    @b

;//----- Identify Device. Opcode = ECh ----------

         mov    [devError],0
         mov    [MsSlave],10100000b       ;//   LBA.Master
         call   GetIdentifyDevice         ;//     
         cmp    [devError],1              ;//   
         jnz    @f                        ;//  - 

         mov    [devError],0
         mov    [MsSlave],10110000b       ;//   LBA.Slave
         call   GetIdentifyDevice
         cmp    [devError],1              ;//   
         jz     @ataNotFound              ;//  -  

@@:      mov    di,[hddCursorPos]
         add    di,36
         push   di di di
;//----------
         mov    ecx,[BarReg]              ;//  
         shl    ecx,16
         mov    [Color],Yellow
         mov    [dataSize],4
         mov    [cursor],di
         call   PrintHex
;//----------
         mov    si,ataBus                 ;//  ATA/SATA
         mov    bx,[devIdAddr]
         mov    ax,word[bx+444]
         shr    ax,12
         or     ax,ax
         jz     @f
         add    si,15
@@:      mov    di,[hddCursorPos]
         add    di,4
         mov    cx,15
         mov    ah,Gray
         call   PrintString
;//----------
         pop    di
         add    di,160
         mov    si,[devIdAddr]
         add    si,54                     ;//  
         mov    cx,40
         mov    ah,Yellow
         call   PrintString
;//----------
         pop    di
         add    di,160*2
         mov    si,[devIdAddr]
         add    si,46                     ;// 
         mov    cx,8
         mov    ah,Yellow
         call   PrintString

         mov    si,[devIdAddr]
         add    si,20                     ;// 
         mov    cx,20
         mov    ah,Yellow
         call   PrintString
;//----------
         pop    di                        ;//   LBA-48
         push   di
         add    di,160*3
         mov    bx,[devIdAddr]
         push   bx bx
         mov    eax,dword[bx+200]
         mov    [Color],Yellow
         call   HexToDec

         add    di,2
         mov    si,equal                  ;//  "="
         mov    ah,Yellow
         mov    cx,1
         call   PrintString

         pop    bx
         finit
         fild   dword[bx+200]
         fimul  dword[secSize]
         fidiv  dword[fpuGb]
         fistp  [diskSize]

         mov    eax,dword[diskSize]       ;//    
         add    di,2
         call   HexToDec
         mov    si,gBt
         mov    ah,Yellow
         mov    cx,3
         call   PrintString
;//----------
         pop    bx di
         add    di,160*4
         mov    ax,word[bx+176]           ;//  UDMA
         mov    si,udmaVer
         bt     ax,14
         jc     @printUdma
         add    si,27
         bt     ax,13
         jc     @printUdma
         add    si,27
@printUdma:
         mov    cx,27
         mov    ah,Yellow
         call   PrintString













@ataNotFound:
         jmp    @GetMenuItem

nvmInfo         db  68 dup(0)


; wUltraDMAmode(176)
;-----------------------------------
; [14]. UDMA-6 133 MB/s
; [13]. UDMA-5 100 MB/s
; [12]. UDMA-4  66 MB/s
udmaVer  db    'UDMA 6. 133 MB/s. Std ATA-7'   ;//  27 
         db    'UDMA 5. 100 MB/s. Std ATA-6'
         db    'UDMA 4. 66 MB/s. Std ATA-5 '

ataHdr   db    '               '    ;//  15
         db    '  Storage name:'
         db    ' Firmware / SN:'
         db    ' Total sectors:'
         db    ' Interface Cap:'

ataBus   db    '  ATA-IDE port:'    ;//  15
         db    ' SATA-IDE port:'

;//-------------------------
align 4
PrintKillSpaceString:
         push   es 0xb800
         pop    es
@@:      lodsb
         stosw
         cmp    al,' '
         jnz    @notSpace
         cmp    byte[si],' '
         jnz    @notSpace
         sub    di,2
@notSpace:
         or     al,al
         jnz    @ascii
         sub    di,2
@ascii:  loop   @b
         pop    es
ret
;//--------------------------------

align 4
GetIdentifyDevice:
         sub    sp,512           ;// Ok!  512-   
         mov    bp,sp            ;// BP =   

         mov    edx,[BarReg]      ;// ATA (1)
         add    dx,6             ;//  "Dev/LBA"
         mov    al,[MsSlave]     ;// Master  Slave
         out    dx,al            ;//
         jmp    $+2              ;//   
 
         mov    edx,[BarReg]      ;//
         add    dx,7             ;//  "Command"
         mov    al,0xEC          ;//  ECh = "IDENTIFY_DEVICE"
         out    dx,al            ;//
         jmp    $+2              ;//

         in     al,dx            ;//   "Status" 
         or     al,al            ;// <------    
         jnz    @wait            ;// OK,  - 
         mov    [devError],1     ;//   = !   ,
         jmp    @noDevice        ;// ...  

@wait:   in     al,dx            ;//  "Status"  
         jmp    $+2              ;//
         test   al,10000000b     ;// <------   "Busy"
         jnz    @wait            ;// 1 =  ! ...

         mov    di,bp            ;// Ok!   STOSW
         mov    ecx,256          ;//  = 256  = 512 
         mov    edx,[BarReg]     ;//   ATA/SATA
@rdIdentify:
         in     ax,dx            ;//    256 !
         stosw                   ;//     -
         loop   @rdIdentify      ;// ....

         mov    di,bp            ;//   .
         add    di,20
         mov    si,di
         mov    ecx,37           ;//  = 37  = 74 
@@:      lodsw
         xchg   ah,al            ;//   
         stosw
         loop   @b

@noDevice:
         mov    [devIdAddr],bp   ;//
         add    sp,512           ;//  ,
ret                              ;// ...  BP    -

;//--------------------------------
;//     
align       16
descTable   dq   0                   ;//    GDT
            dq   0x00cf93000000ffff  ;// 4Gb-   FS
newGdt      dw   $ - descTable       ;//   
gdtBase     dd   0                   ;//    .

SetUnrealMode:
;//*****(1)      GDT *****
         xor    eax,eax         ;//
         mov    ax,ds           ;//
         shl    eax,4           ;//
         add    ax,descTable    ;//
         mov    [gdtBase],eax   ;//
         lgdt   fword[newGdt]   ;//   GDTR!

;//*****(2)     ********************
         cli                  ;//   
         in     al,0x70       ;//  .. NMI
         or     al,10000000b  ;//
         out    0x70,al       ;//
         mov    eax,cr0       ;//
         or     al,1          ;//
         mov    cr0,eax       ;//    P-Mode!
         jmp    $+2           ;//
         mov    ax,8          ;//    GDT
         mov    fs,ax         ;//     FS
         mov    eax,cr0       ;//
         and    al,not 1      ;//
         mov    cr0,eax       ;//    R-Mode!
         jmp    $+2           ;//
         xor    ax,ax         ;//
         mov    fs,ax         ;//
         in     al,0x70       ;//    NMI
         and    al,not 10000000b
         out    0x70,al       ;//
         sti                  ;//
ret



;    bits = 16
;    display 'Current offset is 0x'
;    repeat bits/4
;        d = '0' + $ shr (bits-%*4) and 0Fh
;        if d > '9'
;            d = d + 'A'-'9'-1
;        end if
;        display d
;    end repeat
;    display 13,10
