;//*************************************************************
;//***********   SMBIOS  ***********************************
;//*************************************************************
align 16
@SmbiosPage:
         call   ClearScreen
         mov    di,(160*2)+74      ;//   
         call   SetCheckBox
         mov    dword[CurrentType],0

         push   es 0xf000          ;//   "_SM_"
         pop    es                 ;//  000F:0000  000F:FFFF
         xor    di,di
@@:      cmp    dword[es:di],'_SM_'
         je     @f
         add    di,16
         cmp    di,0xffff
         jnz    @b
         pop    es
         jmp    @exitSmBios

;//-----   SMBIOS ---------------------------------
@@:      mov    ax, [es:di+6]       ;//  SMBIOS
         ror    ax,8
         mov    ebx,[es:di+24]      ;//    DMI
         mov    dx, [es:di+22]      ;//  
         pop    es
         mov    [SmbEntry],di       ;//    _SM_
         mov    [SmbVersion],ax     ;//
         mov    [SmbSize],dx        ;//
         mov    [DmiEntry],ebx      ;//    

;//-----    ----------------------------------
         mov    si,SmBiosHeader
         mov    di,(160*4)+4      ;//   
         mov    cx,50             ;//   
         mov    ah,Gray           ;//  
         mov    bp,3
@@:      push   di cx bp
         call   PrintString
         pop    bp cx di
         add    di,160
         dec    bp
         jnz    @b

         mov    si,MotherBoard
         mov    di,(160*7)+4      ;//   
         mov    cx,12             ;//   
         mov    ah,Gray           ;//  
         mov    bp,17
@@:      push   di cx bp
         call   PrintString
         pop    bp cx di
         add    di,160
         dec    bp
         jnz    @b

;//-----       --------------------------
         mov    ax,[SmbVersion]
         shr    ax,8                    ;// Major
         mov    di,(160*4)+30
         mov    [Color],Yellow
         call   HexToDec
         mov    ax,[SmbVersion]
         and    ax,0xff
         cmp    al,8
         jnz    @f
         mov    [BoardType],1
@@:      mov    di,(160*4)+34           ;// Minor
         call   HexToDec

         mov    ecx,[DmiEntry]          ;// TableEntryPoint
         mov    [cursor],(160*4)+64
         mov    [dataSize],8
         call   PrintHex

         mov    di,(160*4)+106         ;//   SMBIOS
         mov    ax,[SmbSize]
         call   HexToDec
         mov    si,bytes
         mov    ah,Yellow
         mov    cx,5
         call   PrintString

;//-----      ---------------
         mov    eax,[DmiEntry]
         mov    si,ax
         shr    eax,4
         and    ax,0xf000
         mov    [TableSegment],ax
         mov    [CurrentType],si

;//----- Type(0) = BIOS info -----------------------------------
         push   ds [TableSegment]
         pop    ds
         movzx  cx,byte[ds:si+9]   ;//   ROM-BIOS
         mov    bx,[ds:si+20]      ;//   Major/Minor
         push   cx bx
         movzx  ax,byte[ds:si+1]   ;//  
         add    si,ax              ;//   

         mov    ah,Yellow
         mov    di,(160*5)+30      ;//   
         push   di
         mov    cx,2               ;// -   
         mov    bp,1               ;//  : 0=, 1=
         call   GetSmBiosString    ;//   Award/AMI/Phoenix
         pop    di
         add    di,160

         mov    cx,1
         mov    bp,1
         call   GetSmBiosString    ;// 
         pop    ax cx
         pop    ds
         push   cx

         add    di,18
         push   ax                 ;// 
         and    ax,0xff            ;// Major
         mov    [Color],Yellow
         call   HexToDec
         mov    si,point
         mov    ah,Gray
         mov    cx,1
         call   PrintString
         pop    ax
         shr    ax,8               ;// Minor
         call   HexToDec

         pop    ax                 ;//   ROM
         inc    ax
         mov    bx,64
         mul    bx
         mov    di,(160*6)+106     ;//   
         call   HexToDec
         mov    si,kBt
         mov    ah,Yellow
         mov    cx,3
         call   PrintString


;//----- Type(1) = MotherBoard ---------------------------------
;// Board    1  2.
;//   SMBIOS(2.8)  (2),   (1)
@@:      call   FindSmBiosType
         cmp    bl,127
         jz     @CpuType4
         cmp    bl,[BoardType]     ;//  (1)
         jnz    @b

         mov    si,[CurrentType]
         push   ds [TableSegment]
         pop    ds
         xor    ax,ax
         mov    al,[ds:si+1]       ;//  
         add    si,ax              ;//   
         mov    ah,Yellow
         mov    di,(160*8)+30      ;//   
         push   di
         mov    cx,1               ;// -   
         mov    bp,1
         call   GetSmBiosString    ;//  .
         pop    di
         add    di,160
         mov    cx,2
         mov    bp,1
         call   GetSmBiosString    ;//  .
         pop    ds

;//----- Type(4) = Processor ---------------------------------
@CpuType4:
@@:      call   FindSmBiosType
         cmp    bl,127
         jz     @memoryType17
         cmp    bl,4               ;//  (1)
         jnz    @b

         mov    si,[CurrentType]
         push   ds [TableSegment]
         pop    ds
         xor    ax,ax
         mov    al,[ds:si+1]       ;//  
         add    si,ax              ;//   
         mov    ah,Yellow
         mov    di,(160*11)+30     ;//   
         push   di
         mov    cx,2               ;// -   
         mov    bp,1
         call   GetSmBiosString
         pop    di
         add    di,160
         mov    cx,1               ;// -   
         mov    bp,1
         call   GetSmBiosString
         pop    ds

;//-----  
         mov    si,[CurrentType]
         push   ds [TableSegment]
         pop    ds
         mov    ax,word[ds:si+18]    ;// BusClock
         mov    bx,word[ds:si+22]    ;// Speed
         mov    ch,byte[ds:si+35]    ;// CoreCount
         mov    cl,byte[ds:si+37]    ;// ThreadCount
         mov    dl,byte[ds:si+25]    ;// Socket
         pop    ds
         push   dx cx bx

         mov    [Color],Yellow
         mov    di,(160*13)+30
         push   di
         call   HexToDec      ;// BusClock
         mov    ah,Yellow
         mov    cx,4
         mov    si,mHz
         call   PrintString
         pop    di
         add    di,160

         pop    ax            ;// Speed
         push   di
         call   HexToDec
         mov    ah,Yellow
         mov    cx,4
         mov    si,mHz
         call   PrintString
         pop    di
         add    di,160

         pop    ax            ;// AH = Cores, AL = Threads
         push   ax
         shr    ax,8
         push   di
         call   HexToDec      ;// Cores
         pop    di
         add    di,160

         pop    ax
         and    ax,0xFF
         push   di
         call   HexToDec      ;// Threads
         pop    di
         add    di,160
         mov    [cursor],di

         pop    bx            ;// Socket
         and    bx,0xff
         mov    si,SocketTable
         mov    cx,30
@findSocket:
         lodsw
         cmp    ax,bx
         je     @socketFound
         add    si,2
         loop   @findSocket
         sub    si,2
@socketFound:
         mov    si,[si]
         mov    di,[cursor]
         mov    ah,Yellow
         mov    cx,7
         call   PrintString


;//----- Type(17) = MemoryDevice ----------------------------
@memoryType17:
@@:      call   FindSmBiosType
         cmp    bl,127
         jz     @exitSmBios
         cmp    bl,17               ;//  (17)
         jnz    @b

         mov    si,[CurrentType]
         mov    di,[cursor]        ;//   
         add    di,160*2
         mov    [cursor],di

         push   ds [TableSegment]
         pop    ds
         xor    bx,bx
         mov    bl,[ds:si+1]       ;//  
         add    si,bx              ;//   

         mov    ah,Yellow
         mov    cx,2               ;// -   
         mov    bp,0               ;// BP=0 
         call   GetSmBiosString
         mov    cx,3               ;// -   
         mov    bp,1               ;// BP=1 
         call   GetSmBiosString
         pop    ds

@nextMemoryType:
         mov    si,[CurrentType]
         mov    di,[cursor]        ;//   
         add    di,160
         mov    [cursor],di

         push   ds [TableSegment]
         pop    ds
         mov    ax,[ds:si+12]      ;// MemSize
         pop    ds
         push   bx
         call   HexToDec
         mov    si,mBt
         mov    ah,Yellow
         mov    cx,3
         call   PrintString

@@:      call   FindSmBiosType
         cmp    bl,127
         jz     @exitSmBios
         cmp    bl,17               ;//  (17)
         jnz    @b
         jmp    @nextMemoryType

@exitSmBios:
         jmp    @GetMenuItem

align 4
SmbVersion      dw  0
SmbEntry        dw  0
SmbSize         dw  0

DmiEntry        dd  0
TableSegment    dw  0
TableOffset     dw  0

BoardType       db  2
CurrentType     dw  0
StrLenght       dw  0
Color           db  0

SmBiosHeader    db  'SMBIOS ver : 0.0  EntryPoint: 00000000  TableSize:'  ; Byte    ; c(4), (35)
                db  'BIOS Vendor:                                      '  ; Type(0),
                db  '       Data:             Release:         RomSize:'

MotherBoard     db  '            ' ; Type(2), c(07), (12), (17)
                db  'MotherBoard:'
                db  '    Product:'
                db  '            ' ; Type(4), c(10)
                db  'Processor  :' ; Intel Dual Core
                db  '    Product:' ; xxxxxx
                db  '    BusFreq:' ; 0000 MHz
                db  '      Speed:' ; 0000 MHz
                db  '      Cores:' ; 2
                db  '    Threads:' ; 2
                db  '     Socket:' ; LGA1366
                db  '            '
                db  'DDR-SDRAM  :' ; Type(17), c(19)
                db  '    DIMM #1:'
                db  '    DIMM #2:'
                db  '    DIMM #3:'
                db  '    DIMM #4:'

mHz    db ' MHz'
gBt    db ' GB'
mBt    db ' MB'
kBt    db ' KB'
bytes  db ' Byte'
point  db '.'
dpoint db ':'
slash  db '/'
equal  db '='

SocketTable     dw  0x15,@15,0x19,@19,0x1d,@1d,0x1e,@1e,0x1f,@1f,0x20,@20,0x21,@21,0x22,@22,0x23,@23,0x24,@24
                dw  0x25,@25,0x26,@26,0x2b,@26,0x2c,@2c,0x2d,@2d,0x2e,@2e,0x2f,@2f,0x30,@30,0x32,@32,0x33,@33
                dw  0x34,@34,0x35,@35,0x36,@36,0x39,@39,0x3a,@3a,0x3b,@3b,0x3c,@3c,0x3d,@3d,0x3e,@3e,0x01,@Unk  ;30
@15   db  'LGA775 '
@19   db  'LGA1366'
@1d   db  'LGA1156'
@1e   db  'LGA1567'
@1f   db  'PGA988A'
@20   db  'BGA1288'
@21   db  'PGA988B'
@22   db  'BGA1023'
@23   db  'BGA1224'
@24   db  'LGA1155'
@25   db  'LGA1356'
@26   db  'LGA2011'
@2c   db  'LGA1356'
@2d   db  'LGA1150'
@2e   db  'BGA1168'
@2f   db  'BGA1234'
@30   db  'BGA1364'
@32   db  'LGA1151'
@33   db  'BGA1356'
@34   db  'BGA1440'
@35   db  'BGA1515'
@36   db  'LGA3647'
@39   db  'LGA2066'
@3a   db  'BGA1392'
@3b   db  'BGA1510'
@3c   db  'BGA1528'
@3d   db  'LGA4189'
@3e   db  'LGA1200'
@Unk  db  'Unknown'

align 4
GetSmBiosString:              ;// : SI = , DI =   
         push   es 0xb800     ;// CX = - , BP = (1)  (0)
         pop    es            ;//  /
@prn:    lodsb                ;//    DS:SI
         or     al,al         ;//  - ?
         jz     @f            ;//  -  
         or     bp,bp         ;//  ?
         jz     @prn          ;// ..
@true:   stosw                ;//  ,   
         jmp    @prn          ;//
@@:      or     bp,bp
         jz     @f
         mov    al,'.'        ;//  , -
         stosw                ;//
         add    di,2          ;// 
@@:      dec    cx            ;//   -1
         jnz    @prn          ;// ,   .
         pop    es            ;//
ret

align 4
FindSmBiosType:
         push   ds
         mov    si,[CurrentType]     ;//     
         mov    ds,[TableSegment]    ;//  SMBIOS
         xor    ax,ax                ;//
         mov    al,byte[ds:si+1]     ;//  
         mov    bl,byte[ds:si]       ;//   
         add    si,ax                ;//     
@@:      lodsb                       ;//  ..
         or     al,al                ;//  ? ( )
         jnz    @b                   ;//  -  
         cmp    al,byte[ds:si]       ;// :  .  
         jnz    @b                   ;//  -   (  )
         inc    si                   ;//
         mov    bl,byte[ds:si]       ;// : BL =  .
         pop    ds                   ;//
         mov    [CurrentType],si     ;//    !
ret

align 4
HexToDec:
         push   es 0xb800
         pop    es
         xor    ecx,ecx
         mov    ebx,10
@isDiv:  xor    edx,edx
         div    ebx
         push   edx
         inc    ecx
         or     al,al
         jnz    @isDiv
@isOut:  pop    eax
         add    al,'0'
         mov    ah,[Color]
         stosw
         loop   @isOut
         pop    es
ret

